## i3-wm 3.b

=== Makefile ===
UNAME=$(shell uname)
DEBUG=1
INSTALL=install
GIT_VERSION=3.b
VERSION=3.b

CFLAGS += -std=c99
CFLAGS += -pipe
CFLAGS += -Wall
CFLAGS += -Wunused
CFLAGS += -Iinclude
CFLAGS += -I/usr/local/include
CFLAGS += -DI3_VERSION=\"${GIT_VERSION}\"

# Check if pkg-config is installed, because without pkg-config, the following
# check for the version of libxcb cannot be done.
ifeq ($(shell which pkg-config 2>/dev/null 1>/dev/null || echo 1),1)
$(error "pkg-config was not found")
endif

ifeq ($(shell pkg-config --exists xcb-keysyms || echo 1),1)
$(error "pkg-config could not find xcb-keysyms.pc")
endif

ifeq ($(shell pkg-config --exact-version=0.3.3 xcb-keysyms && echo 1),1)
# xcb-keysyms fixed API from 0.3.3 to 0.3.4, so for some months, we will
# have this here. Distributions should upgrade their libxcb in the meantime.
CFLAGS += -DOLD_XCB_KEYSYMS_API
endif

LDFLAGS += -lm
LDFLAGS += -lxcb-event
LDFLAGS += -lxcb-property
LDFLAGS += -lxcb-keysyms
LDFLAGS += -lxcb-atom
LDFLAGS += -lxcb-aux
LDFLAGS += -lxcb-icccm
LDFLAGS += -lxcb-xinerama
LDFLAGS += -lX11
LDFLAGS += -lev
LDFLAGS += -L/usr/local/lib -L/usr/pkg/lib

ifeq ($(UNAME),NetBSD)
# We need -idirafter instead of -I to prefer the system’s iconv over GNU libiconv
CFLAGS += -idirafter /usr/pkg/include
LDFLAGS += -Wl,-rpath,/usr/local/lib -Wl,-rpath,/usr/pkg/lib
endif

ifeq ($(UNAME),FreeBSD)
LDFLAGS += -liconv
endif

ifeq ($(UNAME),Linux)
CFLAGS += -D_GNU_SOURCE
endif

ifeq ($(DEBUG),1)
# Extended debugging flags, macros shall be available in gcc
CFLAGS += -gdwarf-2
CFLAGS += -g3
else
CFLAGS += -O2
endif

# Don’t print command lines which are run
.SILENT:

# Always remake the following targets
.PHONY: install clean dist distclean

# Depend on the object files of all source-files in src/*.c and on all header files
FILES=$(patsubst %.c,%.o,$(wildcard src/*.c))
HEADERS=$(wildcard include/*.h)

# Depend on the specific file (.c for each .o) and on all headers
src/%.o: src/%.c ${HEADERS}
	echo "CC $<"
	$(CC) $(CFLAGS) -c -o $@ $<

all: ${FILES}
	echo "LINK i3"
	$(CC) -o i3 ${FILES} $(LDFLAGS)

install: all
	echo "INSTALL"
	$(INSTALL) -d -m 0755 $(DESTDIR)/usr/bin
	$(INSTALL) -d -m 0755 $(DESTDIR)/etc/i3
	$(INSTALL) -d -m 0755 $(DESTDIR)/usr/share/xsessions
	$(INSTALL) -m 0755 i3 $(DESTDIR)/usr/bin/
	test -e $(DESTDIR)/etc/i3/config || $(INSTALL) -m 0644 i3.config $(DESTDIR)/etc/i3/config
	$(INSTALL) -m 0644 i3.desktop $(DESTDIR)/usr/share/xsessions/

dist: clean
	[ ! -d i3-${VERSION} ] || rm -rf i3-${VERSION}
	[ ! -e i3-${VERSION}.tar.bz2 ] || rm i3-${VERSION}.tar.bz2
	mkdir i3-${VERSION}
	cp DEPENDS GOALS LICENSE PACKAGE-MAINTAINER TODO RELEASE-* i3.config i3.desktop pseudo-doc.doxygen i3-${VERSION}
	cp -r src include man i3-${VERSION}
	# Only copy toplevel documentation (important stuff)
	mkdir i3-${VERSION}/docs
	find docs -maxdepth 1 -type f ! -name "*.xcf" -exec cp '{}' i3-${VERSION}/docs \;
	sed -e 's/^GIT_VERSION=\(.*\)/GIT_VERSION=${GIT_VERSION}/g;s/^VERSION=\(.*\)/VERSION=${VERSION}/g' Makefile > i3-${VERSION}/Makefile
	tar cf i3-${VERSION}.tar i3-${VERSION}
	bzip2 -9 i3-${VERSION}.tar
	rm -rf i3-${VERSION}

clean:
	rm -f src/*.o
	$(MAKE) -C docs clean
	$(MAKE) -C man clean

distclean: clean
	rm -f i3

=== man/Makefile ===
all:
	a2x -f manpage --asciidoc-opts="-f asciidoc.conf" i3.man
clean:
	rm -f i3.xml i3.1 i3.html

## i3-wm 3.d

=== Makefile ===
TOPDIR=$(shell pwd)

include $(TOPDIR)/common.mk

# Depend on the object files of all source-files in src/*.c and on all header files
AUTOGENERATED:=src/cfgparse.tab.c src/cfgparse.yy.c
FILES:=$(filter-out $(AUTOGENERATED),$(wildcard src/*.c))
FILES:=$(FILES:.c=.o)
HEADERS=$(wildcard include/*.h)

# Depend on the specific file (.c for each .o) and on all headers
src/%.o: src/%.c ${HEADERS}
	echo "CC $<"
	$(CC) $(CFLAGS) -c -o $@ $<

all: src/cfgparse.y.o src/cfgparse.yy.o ${FILES}
	echo "LINK i3"
	$(CC) -o i3 ${FILES} src/cfgparse.y.o src/cfgparse.yy.o $(LDFLAGS)
	echo ""
	echo "SUBDIR i3-msg"
	$(MAKE) TOPDIR=$(TOPDIR) -C i3-msg
	echo "SUBDIR i3-input"
	$(MAKE) TOPDIR=$(TOPDIR) -C i3-input

src/cfgparse.yy.o: src/cfgparse.l
	echo "LEX $<"
	flex -i -o$(@:.o=.c) $<
	$(CC) $(CFLAGS) -c -o $@ $(@:.o=.c)

src/cfgparse.y.o: src/cfgparse.y
	echo "YACC $<"
	bison --debug --verbose -b $(basename $< .y) -d $<
	$(CC) $(CFLAGS) -c -o $@ $(<:.y=.tab.c)

install: all
	echo "INSTALL"
	$(INSTALL) -d -m 0755 $(DESTDIR)/usr/bin
	$(INSTALL) -d -m 0755 $(DESTDIR)/etc/i3
	$(INSTALL) -d -m 0755 $(DESTDIR)/usr/share/xsessions
	$(INSTALL) -m 0755 i3 $(DESTDIR)/usr/bin/
	test -e $(DESTDIR)/etc/i3/config || $(INSTALL) -m 0644 i3.config $(DESTDIR)/etc/i3/config
	$(INSTALL) -m 0644 i3.welcome $(DESTDIR)/etc/i3/welcome
	$(INSTALL) -m 0644 i3.desktop $(DESTDIR)/usr/share/xsessions/
	$(MAKE) TOPDIR=$(TOPDIR) -C i3-msg install
	$(MAKE) TOPDIR=$(TOPDIR) -C i3-input install

dist: distclean
	[ ! -d i3-${VERSION} ] || rm -rf i3-${VERSION}
	[ ! -e i3-${VERSION}.tar.bz2 ] || rm i3-${VERSION}.tar.bz2
	mkdir i3-${VERSION}
	cp DEPENDS GOALS LICENSE PACKAGE-MAINTAINER TODO RELEASE-NOTES-${VERSION} i3.config i3.desktop i3.welcome pseudo-doc.doxygen Makefile i3-${VERSION}
	cp -r src i3-msg include man i3-${VERSION}
	# Only copy toplevel documentation (important stuff)
	mkdir i3-${VERSION}/docs
	find docs -maxdepth 1 -type f ! -name "*.xcf" -exec cp '{}' i3-${VERSION}/docs \;
	# Only copy source code from i3-input
	mkdir i3-${VERSION}/i3-input
	find i3-input -maxdepth 1 -type f \( -name "*.c" -or -name "*.h" -or -name "Makefile" \) -exec cp '{}' i3-${VERSION}/i3-input \;
	sed -e 's/^GIT_VERSION:=\(.*\)/GIT_VERSION=${GIT_VERSION}/g;s/^VERSION:=\(.*\)/VERSION=${VERSION}/g' common.mk > i3-${VERSION}/common.mk
	# Pre-generate a manpage to allow distributors to skip this step and save some dependencies
	make -C man
	cp man/*.1 i3-${VERSION}/man/
	tar cfj i3-${VERSION}.tar.bz2 i3-${VERSION}
	rm -rf i3-${VERSION}

clean:
	rm -f src/*.o src/cfgparse.tab.{c,h} src/cfgparse.yy.c
	$(MAKE) -C docs clean
	$(MAKE) -C man clean
	$(MAKE) TOPDIR=$(TOPDIR) -C i3-msg clean
	$(MAKE) TOPDIR=$(TOPDIR) -C i3-input clean

distclean: clean
	rm -f i3
	$(MAKE) TOPDIR=$(TOPDIR) -C i3-msg distclean
	$(MAKE) TOPDIR=$(TOPDIR) -C i3-input distclean

=== docs/Makefile ===

all: hacking-howto.html debugging.html userguide.html

hacking-howto.html: hacking-howto
	asciidoc -a toc -n $<

debugging.html: debugging
	asciidoc -n $<

userguide.html: userguide
	asciidoc -a toc -n $<

clean:
	rm -f */*.{aux,log,toc,bm,pdf,dvi}
	rm -f *.log *.html

=== i3-input/Makefile ===
# Default value so one can compile i3-input standalone
TOPDIR=..

include $(TOPDIR)/common.mk

# Depend on the object files of all source-files in src/*.c and on all header files
FILES=$(patsubst %.c,%.o,$(wildcard *.c))
HEADERS=$(wildcard *.h)

# Depend on the specific file (.c for each .o) and on all headers
%.o: %.c ${HEADERS}
	echo "CC $<"
	$(CC) $(CFLAGS) -c -o $@ $<

all: ${FILES}
	echo "LINK i3-input"
	$(CC) -o i3-input ${FILES} $(LDFLAGS)

install: all
	echo "INSTALL"
	$(INSTALL) -d -m 0755 $(DESTDIR)/usr/bin
	$(INSTALL) -m 0755 i3-input $(DESTDIR)/usr/bin/

clean:
	rm -f *.o

distclean: clean
	rm -f i3-input

=== i3-msg/Makefile ===
# Default value so one can compile i3-msg standalone
TOPDIR=..

include $(TOPDIR)/common.mk

# Depend on the object files of all source-files in src/*.c and on all header files
FILES=$(patsubst %.c,%.o,$(wildcard *.c))
HEADERS=$(wildcard *.h)

# Depend on the specific file (.c for each .o) and on all headers
%.o: %.c ${HEADERS}
	echo "CC $<"
	$(CC) $(CFLAGS) -c -o $@ $<

all: ${FILES}
	echo "LINK i3-msg"
	$(CC) -o i3-msg ${FILES} $(LDFLAGS)

install: all
	echo "INSTALL"
	$(INSTALL) -d -m 0755 $(DESTDIR)/usr/bin
	$(INSTALL) -m 0755 i3-msg $(DESTDIR)/usr/bin/

clean:
	rm -f *.o

distclean: clean
	rm -f i3-msg

=== man/Makefile ===
all:
	a2x -f manpage --asciidoc-opts="-f asciidoc.conf" i3.man
	a2x -f manpage --asciidoc-opts="-f asciidoc.conf" i3-msg.man
	a2x -f manpage --asciidoc-opts="-f asciidoc.conf" i3-input.man
clean:
	rm -f i3.{1,html,xml} i3-msg.{1,html,xml} i3-input.{1,html,xml}

## i3-wm 3.e

=== Makefile ===
TOPDIR=$(shell pwd)

include $(TOPDIR)/common.mk

# Depend on the object files of all source-files in src/*.c and on all header files
AUTOGENERATED:=src/cfgparse.tab.c src/cfgparse.yy.c
FILES:=$(filter-out $(AUTOGENERATED),$(wildcard src/*.c))
FILES:=$(FILES:.c=.o)
HEADERS:=$(filter-out include/loglevels.h,$(wildcard include/*.h))

# Recursively generate loglevels.h by explicitly calling make
# We need this step because we need to ensure that loglevels.h will be
# updated if necessary, but we also want to save rebuilds of the object
# files, so we cannot let the object files depend on loglevels.h.
ifeq ($(MAKECMDGOALS),loglevels.h)
UNUSED:=$(warning Generating loglevels.h)
else
UNUSED:=$(shell $(MAKE) loglevels.h)
endif

# Depend on the specific file (.c for each .o) and on all headers
src/%.o: src/%.c ${HEADERS}
	echo "CC $<"
	$(CC) $(CFLAGS) -DLOGLEVEL="(1 << $(shell awk '/$(shell basename $< .c)/ { print NR }' loglevels.tmp))" -c -o $@ $<

all: src/cfgparse.y.o src/cfgparse.yy.o ${FILES}
	echo "LINK i3"
	$(CC) -o i3 ${FILES} src/cfgparse.y.o src/cfgparse.yy.o $(LDFLAGS)
	echo ""
	echo "SUBDIR i3-msg"
	$(MAKE) TOPDIR=$(TOPDIR) -C i3-msg
	echo "SUBDIR i3-input"
	$(MAKE) TOPDIR=$(TOPDIR) -C i3-input

loglevels.h:
	echo "LOGLEVELS"
	for file in $$(ls src/*.c src/*.y src/*.l | grep -v 'cfgparse.\(tab\|yy\).c'); \
	do \
		echo $$(basename $$file .c); \
	done > loglevels.tmp
	(echo "char *loglevels[] = {"; for file in $$(cat loglevels.tmp); \
	do \
		echo "\"$$file\", "; \
	done; \
	echo "};") > include/loglevels.h;

src/cfgparse.yy.o: src/cfgparse.l src/cfgparse.y.o ${HEADERS}
	echo "LEX $<"
	flex -i -o$(@:.o=.c) $<
	$(CC) $(CFLAGS) -DLOGLEVEL="(1 << $(shell awk '/cfgparse.l/ { print NR }' loglevels.tmp))" -c -o $@ $(@:.o=.c)

src/cfgparse.y.o: src/cfgparse.y ${HEADERS}
	echo "YACC $<"
	bison --debug --verbose -b $(basename $< .y) -d $<
	$(CC) $(CFLAGS) -DLOGLEVEL="(1 << $(shell awk '/cfgparse.y/ { print NR }' loglevels.tmp))" -c -o $@ $(<:.y=.tab.c)

install: all
	echo "INSTALL"
	$(INSTALL) -d -m 0755 $(DESTDIR)$(PREFIX)/bin
	$(INSTALL) -d -m 0755 $(DESTDIR)$(SYSCONFDIR)/i3
	$(INSTALL) -d -m 0755 $(DESTDIR)$(PREFIX)/include/i3
	$(INSTALL) -d -m 0755 $(DESTDIR)$(PREFIX)/share/xsessions
	$(INSTALL) -m 0755 i3 $(DESTDIR)$(PREFIX)/bin/
	$(INSTALL) -m 0755 i3-wsbar $(DESTDIR)$(PREFIX)/bin/
	test -e $(DESTDIR)$(SYSCONFDIR)/i3/config || $(INSTALL) -m 0644 i3.config $(DESTDIR)$(SYSCONFDIR)/i3/config
	$(INSTALL) -m 0644 i3.welcome $(DESTDIR)$(SYSCONFDIR)/i3/welcome
	$(INSTALL) -m 0644 i3.desktop $(DESTDIR)$(PREFIX)/share/xsessions/
	$(INSTALL) -m 0644 include/i3/ipc.h $(DESTDIR)$(PREFIX)/include/i3/
	$(MAKE) TOPDIR=$(TOPDIR) -C i3-msg install
	$(MAKE) TOPDIR=$(TOPDIR) -C i3-input install

dist: distclean
	[ ! -d i3-${VERSION} ] || rm -rf i3-${VERSION}
	[ ! -e i3-${VERSION}.tar.bz2 ] || rm i3-${VERSION}.tar.bz2
	mkdir i3-${VERSION}
	cp DEPENDS GOALS LICENSE PACKAGE-MAINTAINER TODO RELEASE-NOTES-${VERSION} i3.config i3.desktop i3.welcome i3-wsbar pseudo-doc.doxygen Makefile i3-${VERSION}
	cp -r src i3-msg include man yajl-fallback i3-${VERSION}
	# Only copy toplevel documentation (important stuff)
	mkdir i3-${VERSION}/docs
	# Pre-generate documentation
	make -C docs
	find docs -maxdepth 1 -type f ! \( -name "*.xcf" -or -name "*.svg" \) -exec cp '{}' i3-${VERSION}/docs \;
	# Only copy source code from i3-input
	mkdir i3-${VERSION}/i3-input
	find i3-input -maxdepth 1 -type f \( -name "*.c" -or -name "*.h" -or -name "Makefile" \) -exec cp '{}' i3-${VERSION}/i3-input \;
	sed -e 's/^GIT_VERSION:=\(.*\)/GIT_VERSION=${GIT_VERSION}/g;s/^VERSION:=\(.*\)/VERSION=${VERSION}/g' common.mk > i3-${VERSION}/common.mk
	# Pre-generate a manpage to allow distributors to skip this step and save some dependencies
	make -C man
	cp man/*.1 i3-${VERSION}/man/
	tar cfj i3-${VERSION}.tar.bz2 i3-${VERSION}
	rm -rf i3-${VERSION}

clean:
	rm -f src/*.o src/cfgparse.tab.{c,h} src/cfgparse.{output,dot} src/cfgparse.yy.c loglevels.tmp include/loglevels.h
	$(MAKE) -C docs clean
	$(MAKE) -C man clean
	$(MAKE) TOPDIR=$(TOPDIR) -C i3-msg clean
	$(MAKE) TOPDIR=$(TOPDIR) -C i3-input clean

distclean: clean
	rm -f i3
	$(MAKE) TOPDIR=$(TOPDIR) -C i3-msg distclean
	$(MAKE) TOPDIR=$(TOPDIR) -C i3-input distclean

=== docs/Makefile ===

all: hacking-howto.html debugging.html userguide.html ipc.html multi-monitor.html wsbar.html

hacking-howto.html: hacking-howto
	asciidoc -a toc -n $<

debugging.html: debugging
	asciidoc -n $<

userguide.html: userguide
	asciidoc -a toc -n $<

ipc.html: ipc
	asciidoc -a toc -n $<

multi-monitor.html: multi-monitor
	asciidoc -a toc -n $<

wsbar.html: wsbar
	asciidoc -a toc -n $<

clean:
	rm -f */*.{aux,log,toc,bm,pdf,dvi}
	rm -f *.log *.html

=== i3-input/Makefile ===
--- 
+++ 
@@ -18,8 +18,8 @@
 
 install: all
 	echo "INSTALL"
-	$(INSTALL) -d -m 0755 $(DESTDIR)/usr/bin
-	$(INSTALL) -m 0755 i3-input $(DESTDIR)/usr/bin/
+	$(INSTALL) -d -m 0755 $(DESTDIR)$(PREFIX)/bin
+	$(INSTALL) -m 0755 i3-input $(DESTDIR)$(PREFIX)/bin/
 
 clean:
 	rm -f *.o

=== i3-msg/Makefile ===
--- 
+++ 
@@ -2,6 +2,8 @@
 TOPDIR=..
 
 include $(TOPDIR)/common.mk
+
+CFLAGS += -I$(TOPDIR)/include
 
 # Depend on the object files of all source-files in src/*.c and on all header files
 FILES=$(patsubst %.c,%.o,$(wildcard *.c))
@@ -18,8 +20,8 @@
 
 install: all
 	echo "INSTALL"
-	$(INSTALL) -d -m 0755 $(DESTDIR)/usr/bin
-	$(INSTALL) -m 0755 i3-msg $(DESTDIR)/usr/bin/
+	$(INSTALL) -d -m 0755 $(DESTDIR)$(PREFIX)/bin
+	$(INSTALL) -m 0755 i3-msg $(DESTDIR)$(PREFIX)/bin/
 
 clean:
 	rm -f *.o

=== man/Makefile ===
A2M:=a2x -f manpage --asciidoc-opts="-f asciidoc.conf"

all: i3.1 i3-msg.1 i3-input.1 i3-wsbar.1

%.1: %.man asciidoc.conf
	${A2M} $<

i3-wsbar.1: ../i3-wsbar
	pod2man $^ > $@

clean:
	for file in "i3 i3-msg i3-input"; \
	do \
		rm -f $${file}.1 $${file}.html $${file}.xml; \
	done

distclean: clean
	rm -f *.1

## i3-wm 4.1

=== debian/changelog ===
i3-wm (4.1-1) unstable; urgency=low

  * Switch to dpkg-source 3.0 (quilt) and compat level 7
  * Implement system tray support in i3bar (for NetworkManager, Skype, …)
  * i3bar is now configurable in the i3 configfile
  * Implement support for PCRE regular expressions in criteria
  * Implement a new assign syntax which uses criteria
  * Sort named workspaces whose name starts with a number accordingly
  * Warn on duplicate bindings for the same key
  * Restrict 'resize' command to left/right for horizontal containers, up/down
    for vertical containers
  * Implement support for startup notifications (cursor will change to 'watch',
    started applications show up on the workspace they have been launched on)
  * Implement the GET_MARKS IPC request to get all marks
  * Implement the new_float config option (border style for floating windows)
  * Implement passing IPC sockets to i3 (systemd-style socket activation)
  * Implement the 'move output' command to move containers to a specific output
  * Implement focus switching for floating windows
  * Implement the window_role criterion (for matching multi-window apps)
  * Implement a force_xinerama configuration directive
  * Implement the --get-socketpath, useful for scripts using the IPC interface
  * Implement the 'move workspace next' and 'move workspace prev' commands
  * Implement the 'workspace back_and_forth' command and related configuration
    option
  * Implement the move command for floating windows
  * i3 will now handle arbitrary text arguments by sending them as an IPC
    command, like i3-msg: 'i3 reload' or 'i3 move workspace 3'
  * Introduce the i3-sensible-{pager,editor,terminal} scripts to execute
    $PAGER, $EDITOR or an available terminal emulator
  * i3-input: implement -F (format) option
  * Bugfix: Preserve marks when restarting
  * Bugfix: Correctly free old assignments when reloading
  * Bugfix: Fix flickering when moving floating windows between monitors
  * Bugfix: Correctly handle ConfigureRequests for floating windows in a
    multi-monitor environment.
  * Bugfix: Fix size of floating windows with X11 borders
  * Bugfix: Always adjust floating window position when moving to another
    output
  * Bugfix: Avoid out-of-bounds coordinates when moving floating windows
  * Bugfix: Don’t steal focus when a window gets destroyed
  * Bugfix: Correctly split key/value when parsing variables
  * Bugfix: Correctly revert focus to other floating windows when closing a
    floating window
  * Bugfix: Don’t leak the error logfile file descriptor
  * Bugfix: Don’t steal focus when a window opens on an invisible workspace due
    to assignments
  * Bugfix: Fix handling of Mode_switch in i3-input
  * Bugfix: Close invisible workspaces when they become empty
  * Bugfix: Don’t invoke interactive resizing when clicking on the decoration
    of a split container with more than one child (switch focus instead)
  * Bugfix: Make named workspace assignments work again
  * Bugfix: RandR: Correctly keep focus on the focused workspace when an output
    disappears
  * Bugfix: Insert container at the correct position on workspace level when
    workspace_layout == default

 -- Michael Stapelberg <michael@stapelberg.de>  Fri, 11 Nov 2011 21:28:15 +0000

i3-wm (4.0.2-1) unstable; urgency=low

  * i3-config-wizard: handle mouse button clicks on <win> and <alt> texts
  * i3-config-wizard: check the modifier mapping to decide whether to use Mod1
    or Mod4
  * migrate-config: use \s, be a bit more whitespace tolerant
  * userguide: s/mod+h/mod+s for stacking
  * userguide: provide the default colors in the colors example
  * userguide: document force_focus_wrapping directive
  * userguide: properly document the resize command
  * userguide: properly document command chaining and criteria
  * Bugfix: Correctly bind on multiple keycodes if a symbol has more than one
  * Bugfix: Allow multiple criteria in 'for_window'
  * Bugfix: Ensure a minimum size when using the 'resize' command
  * Bugfix: Start on the first named workspace, not always on '1'
  * Bugfix: Fix resize command with direction != up for floating windows
  * Bugfix: Correctly set the _NET_CLIENT_LIST_STACKING hint (chromium tabbar)
  * Bugfix: 'workspace <next|prev>' now takes all outputs into account
  * Bugfix: i3-wsbar: make workspace names clickable again
  * Bugfix: i3-wsbar: correctly handle EOF on stdin
  * Bugfix: i3-wsbar: display a separator between workspaces of each output
  * Bugfix: Correctly handle the 'instance' criterion (WM_CLASS)
  * Bugfix: Use correct format string in load_layout (fixes crash in restart)
  * Bugfix: Fix border rendering (border lines were "cutting" through)
  * Bugfix: Raise floating windows immediately when dragging/resizing
  * Bugfix: Make focus switching work accross outputs again
  * Bugfix: migration-script: handle resize top/bottom correctly
  * Bugfix: Fix focus issue when moving containers to workspaces
  * Bugfix: Warp cursor when changing outputs again
  * Bugfix: i3bar: fix switching to workspaces with extremely long names
  * Bugfix: i3bar: fix switching to workspaces "next" and "prev"
  * Bugfix: i3bar: Correctly allocate pixmap for statuslines which are longer
    than the screen
  * Bugfix: i3bar: set statusline = NULL on EOF / SIGCHLD
  * Bugfix: Correctly initialize the verbose flag
  * Bugfix: Don’t start with workspace 'next' when the command 'workspace next'
    is bound in the config file
  * Bugfix: Set focus to where the mouse pointer is when starting
  * Bugfix: Don’t change focus when assigned windows start on invisible
    workspaces
  * Bugfix: Don’t use absolute paths for exec in the config file
  * Bugfix: Fix crash when using 'focus mode_toggle' on an empty workspace
  * Bugfix: Make the 'resize' command work inside tabbed/stacked cons
  * Bugfix: Correctly place floating windows on their appropriate output
  * Bugfix: Fix coordinates when moving a floating window to a different output


=== debian/rules ===
#!/usr/bin/make -f
# vi: ts=8 sw=8 noet

DPKG_EXPORT_BUILDFLAGS = 1
-include /usr/share/dpkg/buildflags.mk

build: build-stamp
build-stamp:
	dh build
	touch build-stamp

clean:
	dh clean

install: build install-stamp
install-stamp:
	dh install
	touch install-stamp

binary-arch: install
	dh binary-arch

binary-indep: install
	dh binary-indep

binary: binary-arch binary-indep

override_dh_auto_build:
	$(MAKE)
	$(MAKE) -C man
	$(MAKE) -C docs

override_dh_install:
	$(MAKE) DESTDIR=$(CURDIR)/debian/i3-wm/ install

override_dh_strip:
	dh_strip --dbg-package=i3-wm-dbg

## i3-wm 4.1.1

=== Makefile ===
TOPDIR=$(shell pwd)

include $(TOPDIR)/common.mk

# Depend on the object files of all source-files in src/*.c and on all header files
AUTOGENERATED:=src/cfgparse.tab.c src/cfgparse.yy.c src/cmdparse.tab.c src/cmdparse.yy.c
FILES:=$(filter-out $(AUTOGENERATED),$(wildcard src/*.c))
FILES:=$(FILES:.c=.o)
HEADERS:=$(filter-out include/loglevels.h,$(wildcard include/*.h))

# Recursively generate loglevels.h by explicitly calling make
# We need this step because we need to ensure that loglevels.h will be
# updated if necessary, but we also want to save rebuilds of the object
# files, so we cannot let the object files depend on loglevels.h.
ifeq ($(MAKECMDGOALS),loglevels.h)
#UNUSED:=$(warning Generating loglevels.h)
else
UNUSED:=$(shell $(MAKE) loglevels.h)
endif

SUBDIRS:=i3-msg i3-input i3-nagbar i3-config-wizard i3bar

# Depend on the specific file (.c for each .o) and on all headers
src/%.o: src/%.c ${HEADERS}
	echo "[i3] CC $<"
	$(CC) $(CPPFLAGS) $(CFLAGS) -DLOGLEVEL="((uint64_t)1 << $(shell awk '/$(shell basename $< .c)/ { print NR; exit 0; }' loglevels.tmp))" -c -o $@ $<

all: i3 subdirs

i3: libi3/libi3.a src/cfgparse.y.o src/cfgparse.yy.o src/cmdparse.y.o src/cmdparse.yy.o ${FILES}
	echo "[i3] LINK i3"
	$(CC) $(LDFLAGS) -o $@ $(filter-out libi3/libi3.a,$^) $(LIBS)

libi3/%.a: libi3/*.c
	$(MAKE) -C libi3

subdirs:
	for dir in $(SUBDIRS); do \
		echo ""; \
		echo "MAKE $$dir"; \
		$(MAKE) -C $$dir; \
	done

loglevels.h:
	echo "[i3] LOGLEVELS"
	for file in $$(ls src/*.c src/*.y src/*.l | grep -v 'cfgparse.\(tab\|yy\).c'); \
	do \
		echo $$(basename $$file .c); \
	done > loglevels.tmp
	(echo "char *loglevels[] = {"; for file in $$(cat loglevels.tmp); \
	do \
		echo "\"$$file\", "; \
	done; \
	echo "};") > include/loglevels.h;

src/cfgparse.yy.o: src/cfgparse.l src/cfgparse.y.o ${HEADERS}
	echo "[i3] LEX $<"
	flex -i -o$(@:.o=.c) $<
	$(CC) $(CPPFLAGS) $(CFLAGS) -DLOGLEVEL="(1 << $(shell awk '/cfgparse.l/ { print NR }' loglevels.tmp))" -c -o $@ $(@:.o=.c)

src/cmdparse.yy.o: src/cmdparse.l src/cmdparse.y.o ${HEADERS}
	echo "[i3] LEX $<"
	flex -Pcmdyy -i -o$(@:.o=.c) $<
	$(CC) $(CPPFLAGS) $(CFLAGS) -DLOGLEVEL="(1 << $(shell awk '/cmdparse.l/ { print NR }' loglevels.tmp))" -c -o $@ $(@:.o=.c)


src/cfgparse.y.o: src/cfgparse.y ${HEADERS}
	echo "[i3] YACC $<"
	bison --debug --verbose -b $(basename $< .y) -d $<
	$(CC) $(CPPFLAGS) $(CFLAGS) -DLOGLEVEL="(1 << $(shell awk '/cfgparse.y/ { print NR }' loglevels.tmp))" -c -o $@ $(<:.y=.tab.c)

src/cmdparse.y.o: src/cmdparse.y ${HEADERS}
	echo "[i3] YACC $<"
	bison -p cmdyy --debug --verbose -b $(basename $< .y) -d $<
	$(CC) $(CPPFLAGS) $(CFLAGS) -DLOGLEVEL="(1 << $(shell awk '/cmdparse.y/ { print NR }' loglevels.tmp))" -c -o $@ $(<:.y=.tab.c)


install: all
	echo "[i3] INSTALL"
	$(INSTALL) -d -m 0755 $(DESTDIR)$(PREFIX)/bin
	$(INSTALL) -d -m 0755 $(DESTDIR)$(SYSCONFDIR)/i3
	$(INSTALL) -d -m 0755 $(DESTDIR)$(PREFIX)/include/i3
	$(INSTALL) -d -m 0755 $(DESTDIR)$(PREFIX)/share/xsessions
	$(INSTALL) -m 0755 i3 $(DESTDIR)$(PREFIX)/bin/
	$(INSTALL) -m 0755 i3-migrate-config-to-v4 $(DESTDIR)$(PREFIX)/bin/
	$(INSTALL) -m 0755 i3-sensible-editor $(DESTDIR)$(PREFIX)/bin/
	$(INSTALL) -m 0755 i3-sensible-pager $(DESTDIR)$(PREFIX)/bin/
	$(INSTALL) -m 0755 i3-sensible-terminal $(DESTDIR)$(PREFIX)/bin/
	test -e $(DESTDIR)$(SYSCONFDIR)/i3/config || $(INSTALL) -m 0644 i3.config $(DESTDIR)$(SYSCONFDIR)/i3/config
	test -e $(DESTDIR)$(SYSCONFDIR)/i3/config.keycodes || $(INSTALL) -m 0644 i3.config.keycodes $(DESTDIR)$(SYSCONFDIR)/i3/config.keycodes
	$(INSTALL) -m 0644 i3.welcome $(DESTDIR)$(SYSCONFDIR)/i3/welcome
	$(INSTALL) -m 0644 i3.desktop $(DESTDIR)$(PREFIX)/share/xsessions/
	$(INSTALL) -m 0644 include/i3/ipc.h $(DESTDIR)$(PREFIX)/include/i3/
	for dir in $(SUBDIRS); do \
		$(MAKE) -C $$dir install; \
	done

dist: distclean
	[ ! -d i3-${VERSION} ] || rm -rf i3-${VERSION}
	[ ! -e i3-${VERSION}.tar.bz2 ] || rm i3-${VERSION}.tar.bz2
	mkdir i3-${VERSION}
	cp i3-migrate-config-to-v4 i3-sensible-* i3.config.keycodes DEPENDS GOALS LICENSE PACKAGE-MAINTAINER RELEASE-NOTES-${VERSION} i3.config i3.desktop i3.welcome pseudo-doc.doxygen i3-wsbar Makefile i3-${VERSION}
	cp -r src libi3 i3-msg i3-nagbar i3-config-wizard i3bar yajl-fallback include man i3-${VERSION}
	# Only copy toplevel documentation (important stuff)
	mkdir i3-${VERSION}/docs
	# Pre-generate documentation
	$(MAKE) -C docs
	$(MAKE) -C i3bar/doc
	# Cleanup τεχ output files
	find docs -regex ".*\.\(aux\|out\|log\|toc\|bm\|dvi\|log\)" -exec rm '{}' \;
	find docs -maxdepth 1 -type f ! \( -name "*.xcf" -or -name "*.svg" \) -exec cp '{}' i3-${VERSION}/docs \;
	# Only copy source code from i3-input
	mkdir i3-${VERSION}/i3-input
	find i3-input -maxdepth 1 -type f \( -name "*.c" -or -name "*.h" -or -name "Makefile" \) -exec cp '{}' i3-${VERSION}/i3-input \;
	sed -e 's/^GIT_VERSION:=\(.*\)/GIT_VERSION:=$(shell /bin/echo '${GIT_VERSION}' | sed 's/\\/\\\\/g')/g;s/^VERSION:=\(.*\)/VERSION:=${VERSION}/g' common.mk > i3-${VERSION}/common.mk
	# Pre-generate a manpage to allow distributors to skip this step and save some dependencies
	$(MAKE) -C man
	cp man/*.1 i3-${VERSION}/man/
	cp i3bar/doc/*.1 i3-${VERSION}/i3bar/doc/
	tar cfj i3-${VERSION}.tar.bz2 i3-${VERSION}
	rm -rf i3-${VERSION}

clean:
	rm -f src/*.o src/*.gcno src/cfgparse.tab.{c,h} src/cfgparse.yy.c src/cfgparse.{output,dot} src/cmdparse.tab.{c,h} src/cmdparse.yy.c src/cmdparse.{output,dot} loglevels.tmp include/loglevels.h
	(which lcov >/dev/null 2>&1 && lcov -d . --zerocounters) || true
	$(MAKE) -C libi3 clean
	$(MAKE) -C docs clean
	$(MAKE) -C man clean
	for dir in $(SUBDIRS); do \
		echo ""; \
		echo "CLEAN $$dir"; \
		$(MAKE) TOPDIR=$(TOPDIR) -C $$dir distclean; \
	done

distclean: clean
	rm -f i3
	for dir in $(SUBDIRS); do \
		echo ""; \
		echo "DISTCLEAN $$dir"; \
		$(MAKE) TOPDIR=$(TOPDIR) -C $$dir distclean; \
	done

coverage:
	rm -f /tmp/i3-coverage.info
	rm -rf /tmp/i3-coverage
	lcov -d . -b . --capture -o /tmp/i3-coverage.info
	genhtml -o /tmp/i3-coverage/ /tmp/i3-coverage.info

=== debian/changelog ===
i3-wm (4.1.1-1) unstable; urgency=low

  * Re-add build-arch/build-indep targets to debian/rules (Closes: #648613)
  * Create a secure temp path instead of a predictable one
  * ipc: set CLOEXEC on client file descriptors
  * Fix prototype in include/xcursor.h
  * Bugfix: Skip dock clients when handling FocusIn events
  * Bugfix: Fix fullscreen with floating windows
  * Bugfix: Fix startup when RandR is not present
  * Bugfix: Retain window position and size when changing floating border
  * Bugfix: Disallow focusing dock clients via criteria
  * Bugfix: Don’t create a workspace named 'back_and_forth' on startup
  * Bugfix: Fix wrong focus in complex tabbed/stacked layouts
  * Bugfix: Fix resizing for (e.g.) v-split containers in h-split containers
  * Bugfix: Fix 'resize' command in nested containers
  * Bugfix: Don’t set the _NET_WM_WORKAREA hint at all
  * Bugfix: Skip leading whitespace in variable assignments
  * Bugfix: Make resizing of tiling windows with floating_modifier use absolute
    coordinates
  * Bugfix: Make resizing work when pressing floating_modifier + right mouse
    button on window decorations
  * Bugfix: Fix setting the same mark repeatedly on different windows
  * Bugfix: Disallow focusing other windows when in fullscreen mode
  * Bugfix: Ignore ConfigureRequests with out-of-bound coordinates
  * Bugfix: Correctly check boundaries and reassign floating windows when
    moving
  * Bugfix: Don’t close workspace when there are still floating windows on it

 -- Michael Stapelberg <michael@stapelberg.de>  Sat, 24 Dec 2011 16:23:55 +0100

## i3-wm 4.1.2

=== docs/Makefile ===
# To pass additional parameters for asciidoc
ASCIIDOC=asciidoc

all: hacking-howto.html debugging.html userguide.html ipc.html multi-monitor.html wsbar.html refcard.pdf testsuite.html

hacking-howto.html: hacking-howto
	$(ASCIIDOC) -a toc -n $<

debugging.html: debugging
	$(ASCIIDOC) -n $<

userguide.html: userguide
	$(ASCIIDOC) -a toc -n $<

testsuite.html: testsuite
	$(ASCIIDOC) -a toc -n $<

ipc.html: ipc
	$(ASCIIDOC) -a toc -n $<

multi-monitor.html: multi-monitor
	$(ASCIIDOC) -a toc -n $<

wsbar.html: wsbar
	$(ASCIIDOC) -a toc -n $<

refcard.pdf: refcard.tex
	pdflatex refcard.tex && pdflatex refcard.tex

clean:
	find . -regex ".*\.\(aux\|out\|log\|toc\|bm\|pdf\|dvi\|log\|html\)" -exec rm '{}' \;

=== i3-config-wizard/Makefile ===
# Default value so one can compile i3-input standalone
TOPDIR=..

include $(TOPDIR)/common.mk

# Depend on the object files of all source-files in src/*.c and on all header files
AUTOGENERATED:=cfgparse.tab.c cfgparse.yy.c
FILES:=$(patsubst %.c,%.o,$(filter-out $(AUTOGENERATED),$(wildcard *.c)))
HEADERS:=$(wildcard *.h)

CPPFLAGS += -I$(TOPDIR)/include

# Depend on the specific file (.c for each .o) and on all headers
%.o: %.c ${HEADERS}
	echo "[i3-config-wizard] CC $<"
	$(CC) $(CPPFLAGS) $(CFLAGS) -c -o $@ $<

all: i3-config-wizard

i3-config-wizard: $(TOPDIR)/libi3/libi3.a cfgparse.y.o cfgparse.yy.o ${FILES}
	echo "[i3-config-wizard] LINK i3-config-wizard"
	$(CC) $(LDFLAGS) -o $@ $(filter-out libi3/libi3.a,$^) $(LIBS)

$(TOPDIR)/libi3/%.a: $(TOPDIR)/libi3/*.c
	$(MAKE) -C $(TOPDIR)/libi3

cfgparse.yy.o: cfgparse.l cfgparse.y.o ${HEADERS}
	echo "[i3-config-wizard] LEX $<"
	flex -i -o$(@:.o=.c) $<
	$(CC) $(CPPFLAGS) $(CFLAGS) -c -o $@ $(@:.o=.c)

cfgparse.y.o: cfgparse.y ${HEADERS}
	echo "[i3-config-wizard] YACC $<"
	bison --debug --verbose -b $(basename $< .y) -d $<
	$(CC) $(CPPFLAGS) $(CFLAGS) -c -o $@ $(<:.y=.tab.c)


install: all
	echo "[i3-config-wizard] INSTALL"
	$(INSTALL) -d -m 0755 $(DESTDIR)$(PREFIX)/bin
	$(INSTALL) -m 0755 i3-config-wizard $(DESTDIR)$(PREFIX)/bin/

clean:
	rm -f *.o cfgparse.tab.{c,h} cfgparse.output cfgparse.yy.c

distclean: clean
	rm -f i3-config-wizard

=== man/Makefile ===
A2M:=a2x -f manpage --asciidoc-opts="-f asciidoc.conf"

all: i3.1 i3-msg.1 i3-input.1 i3-nagbar.1 i3-wsbar.1 i3-config-wizard.1 i3-migrate-config-to-v4.1 i3-sensible-editor.1 i3-sensible-pager.1 i3-sensible-terminal.1

%.1: %.man asciidoc.conf
	${A2M} $<

i3-wsbar.1: ../i3-wsbar
	pod2man $^ > $@

clean:
	for file in $$(echo i3 i3-msg i3-input i3-nagbar i3-wsbar i3-config-wizard i3-migrate-config-to-v4 i3-sensible-editor i3-sensible-pager i3-sensible-terminal); \
	do \
		rm -f $${file}.1 $${file}.html $${file}.xml; \
	done

distclean: clean
	rm -f *.1

=== debian/changelog ===
i3-wm (4.1.2-2) unstable; urgency=low

  * Rebuild against libyajl and libxcb from unstable

 -- Michael Stapelberg <michael@stapelberg.de>  Fri, 27 Jan 2012 19:50:29 +0000

i3-wm (4.1.2-1) unstable; urgency=low

  * Bugfix: Don’t lose focus on fullscreen windows when another window gets
    moved to that workspace
  * Bugfix: Open new windows in the correct place when assignments match
  * Bugfix: Fix assignments of floating windows to (yet) unused workspaces
  * Bugfix: Either use SetInputFocus *or* send WM_TAKE_FOCUS, not both
  * Bugfix: Respect WM_HINTS.input for WM_TAKE_FOCUS clients
  * Bugfix: Setup the _NET_SUPPORTING_WM_CHECK atom in a standards-compliant
    way
  * Bugfix: Only ignore EnterNotify events after UnmapNotifies from managed
    windows
  * Bugfix: Force a new sequence number after UnmapNotify
  * Bugfix: Position floating windows exactly where their geometry specified
  * Bugfix: Fix coordinates when the rect of an output changes

 -- Michael Stapelberg <michael@stapelberg.de>  Fri, 27 Jan 2012 19:04:28 +0000

=== debian/control ===
Source: i3-wm
Section: utils
Priority: extra
Maintainer: Michael Stapelberg <michael@stapelberg.de>
DM-Upload-Allowed: yes
Build-Depends: debhelper (>= 7.0.50~), libx11-dev, libxcb-util0-dev (>= 0.3.8), libxcb-keysyms1-dev, libxcb-xinerama0-dev (>= 1.1), libxcb-randr0-dev, libxcb-icccm4-dev, libxcursor-dev, asciidoc (>= 8.4.4), xmlto, docbook-xml, pkg-config, libev-dev, flex, bison, libyajl-dev, texlive-latex-base, texlive-latex-recommended, texlive-latex-extra, libpcre3-dev, libstartup-notification0-dev (>= 0.10)
Standards-Version: 3.9.2
Homepage: http://i3wm.org/

Package: i3
Architecture: any
Section: x11
Depends: i3-wm, ${misc:Depends}
Recommends: i3lock, suckless-tools, i3status
Description: metapackage (i3 window manager, screen locker, menu, statusbar)
 This metapackage installs the i3 window manager (i3-wm), the i3lock screen
 locker, i3status (for system information) and suckless-tools (for dmenu).
 These are all the tools you need to use the i3 window manager efficiently.

Package: i3-wm
Architecture: any
Section: x11
Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends}, x11-utils
Provides: x-window-manager
Suggests: rxvt-unicode | x-terminal-emulator
Recommends: xfonts-base
Description: improved dynamic tiling window manager
 Key features of i3 are good documentation, reasonable defaults (changeable in
 a simple configuration file) and good multi-monitor support. The user
 interface is designed for power users and emphasizes keyboard usage. i3 uses
 XCB for asynchronous communication with X11 and aims to be fast and
 light-weight.
 .
 Please be aware i3 is primarily targeted at advanced users and developers.

Package: i3-wm-dbg
Architecture: any
Section: debug
Depends: i3-wm (=${binary:Version}), ${misc:Depends}
Description: Debugging symbols for the i3 window manager
 Debugging symbols for the i3 window manager. Please install this to produce
 useful backtraces before creating new tickets.
